/***********************************************************************

GECCO, a platform for command and control gaming

Copyright (C) 2001 Henrik Bäärnhielm, Andreas Enblom, Niklas
Hallenfur, Karl Hasselström, Henrik Hägerström, Oskar Linde, Jing Fu
Zi and Jon Åslund

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or (at
your option) any later version.

This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
USA.

***********************************************************************/

package gecco.client.infopanels;
import gecco.client.*;
import java.awt.*;

import java.util.*;
import javax.swing.*;

/**
 *  This panel contains the messages of a Piece. They are presented in a
 *  scrollable list.
 *
 * @author     Andreas Enblom
 * @created    June 27, 2001
 */
public class MessageDisplay extends JScrollPane {
    /**
     *  Description of the Field
     */
    Piece piece;
    /**
     *  Description of the Field
     */
    JTextArea messages;


    /**
     *  Constructor for the MessageDisplay object
     */
    public MessageDisplay() {
        messages = new JTextArea();
        messages.setEditable(false);
        setVerticalScrollBarPolicy(VERTICAL_SCROLLBAR_ALWAYS);
        setHorizontalScrollBarPolicy(HORIZONTAL_SCROLLBAR_AS_NEEDED);
        setViewportView(messages);
    }


    /**
     *  Sets the piece whose messages are displayed.
     *
     * @param  p  The new Piece value
     */
    public void setPiece(Piece p) {
        piece = p;
        if (piece == null) {
            messages.setText("");
            return;
        }
        Enumeration e = piece.getMessages();
        String content = "";
        while (e.hasMoreElements()) {
            String line = (String) e.nextElement() + "\n";
            content = content + line;
        }
        JScrollBar scrollbar = getVerticalScrollBar();
        scrollbar.setValue(scrollbar.getMaximum() - 1);
        messages.setText(content);
    }
}
